cbuffer cbPerFrame : register(b0)
{
	float4x4 matVP;
	float4x4 matGeo;
};

struct PosColor{
	float3 pos;
	float3 color;
};

struct VSInput
{
	float4 pos : POSITION;
	uint id : SV_InstanceID;
};

struct VSOutput
{
	float4 pos : SV_POSITION;
	float4 color : COLOR;
};

RWStructuredBuffer<PosColor> pc : register(u0);

VSOutput main(VSInput vin) {
	int i = vin.id;
	VSOutput vout = VSOutput(0);
	float4 pos = vin.pos + float4(pc[i].pos, 1);
	float3 color = pc[i].color;
	
	//float4 pos = float4(0, 0, 0, 1);
	//float3 color = float3(1.0f, 0, 1.0f);

	vout.color = float4(color, 1.0);
	vout.pos = mul(mul(pos, matGeo), matVP);
	return vout;
}
